<script>
import { ref } from 'vue'
import axios from 'axios'
import Message from './Message.vue'
import { useUserStore } from "../store/user";
import { NCard, NSpace, NSteps, NStep, NButton, NInput, NFormItem, NForm, NFormItemRow, NSelect, NUpload, NUploadDragger, NIcon, NP, NText, NDynamicInput, NCheckbox, NCheckboxGroup } from 'naive-ui';
import { ArchiveBoxIcon } from '@heroicons/vue/24/solid'
export default {
  data() {
    return {
      formValue: {},
    }
  },
  components: {
    Message,
    ArchiveBoxIcon,
    NCard,
    NSpace,
    NSteps,
    NStep,
    NButton,
    NInput,
    NFormItem,
    NForm,
    NFormItemRow,
    NSelect,
    NUpload,
    NUploadDragger,
    NIcon,
    NP,
    NText,
    NDynamicInput,
    NCheckbox,
    NCheckboxGroup
  },
  methods: {
    async submit() {
      try {
        var response = await axios.post("https://cognoro.xyz/course/create", this.formValue);
        window.$message.success(
                'Course was added.'
              )
      } catch {
        window.$message.error(
                'Please check the data and try again.'
              )
      }
      },

    async beforeUpload(data) {
        formValue.audio = data.file.file?.name;
        return true;
      },

  },
  async prepare(data) {
    if (this.userStore.expiration * 1000 - Date.now() < 0) {
      await this.userStore.refresh();
    }
  },
  async setup() {
    const formRef = ref(null);
    const currentRef = ref(1);
    const userStore = useUserStore();
    if (userStore.expiration * 1000 - Date.now() < 0 || userStore.auth_token == null) {
      await userStore.refresh();
    }
    axios.defaults.headers.common['Authorization'] = userStore.auth_token;
    return {
      userStore, currentRef, formRef, currentStatus: ref("process"), headers: {Authentication: `Bearer ${userStore.auth_token}`},
    };
  },
};
</script>

<template>
  <Message/>
  <n-card class="sub">
    <n-space vertical>
      <n-steps :current="(currentRef)" :status="currentStatus">
        <n-step title="Course" description="" />
      </n-steps>
      <n-form ref="formRef" :model="formValue">
        <n-form-item-row label="Name" path="name">
          <n-input v-model:value="formValue.name"/>
        </n-form-item-row>
        <n-form-item-row label="Locale" path="locale">
          <n-input v-model:value="formValue.locale" />
        </n-form-item-row>
      </n-form>
      <div>
        <n-button ghost color="#ff69b4" attr-type="submit" @click="submit">
          Submit
        </n-button>
      </div>
    </n-space>
  </n-card>
</template>